﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PoE_MxFilterGen.generator
{
    internal class scarab
    {
        private static string iBbasic;
        private static string iB5c;
        private static string iB10c;
        private static string iB100c;
        private static string iBhigh;

        public static void Gen(string section)
        {
            List<string> stringList = new List<string>();
            foreach (Line line in JsonConvert.DeserializeObject<Root>(File.ReadAllText("data/ninja.scarab.json", Encoding.UTF8)).lines)
            {               
                int chaosValue = Convert.ToInt32(line.chaosValue);
                if (chaosValue <= 1.0)
                {
                    stringList.Add(line.name);
                    scarab.iBbasic += string.Format(@" ""{0}""", line.name);
                }
                if (chaosValue <= 5.0 && chaosValue > 1.0)
                {
                    stringList.Add(line.name);
                    scarab.iB5c += string.Format(@" ""{0}""", line.name);
                }
                if (chaosValue <= 10.0 && chaosValue > 5.0)
                {
                    stringList.Add(line.name);
                    scarab.iB10c += string.Format(@" ""{0}""", line.name);
                }
                if (chaosValue <= 100.0 && chaosValue > 10.0)
                {                  
                    stringList.Add(line.name);
                    scarab.iB100c += string.Format(@" ""{0}""", line.name);
                }
                if (chaosValue > 100.0)
                {
                    stringList.Add(line.name);
                    scarab.iBhigh += string.Format(@" ""{0}""", line.name);
                }
            }
            string path = "gen/" + section + ".filter";
            if (scarab.iBbasic == null)
                scarab.iBbasic = "\"\"";            
            File.AppendAllText(path, string.Format("#### SECTION: {0}", (object)section) + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Class \"Map Fragment\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType" + scarab.iBbasic + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 94 3 3" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 25" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_scarab.mp3\"", Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine, Encoding.UTF8);

            if (scarab.iB5c == null)
                scarab.iB5c = "\"\"";
            File.AppendAllText(path, string.Format("#### SECTION: {0}", (object)section) + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Class \"Map Fragment\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType" + scarab.iB5c + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 94 3 3" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 30" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_scarab.mp3\"", Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine, Encoding.UTF8);

            if (scarab.iB10c == null)
                scarab.iB10c = "\"\"";
            File.AppendAllText(path, string.Format("#### SECTION: {0}", (object)section) + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Class \"Map Fragment\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType" + scarab.iB10c + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 94 3 3" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_scarab.mp3\"", Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine, Encoding.UTF8);

            if (scarab.iB100c == null)
                scarab.iB100c = "\"\"";
            File.AppendAllText(path, string.Format("#### SECTION: {0}", (object)section) + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Class \"Map Fragment\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType" + scarab.iB100c + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 94 3 3" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 40" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_scarab.mp3\"", Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine, Encoding.UTF8);

            if (scarab.iBhigh == null)
                scarab.iBhigh = "\"\"";
            File.AppendAllText(path, string.Format("#### SECTION: {0}", (object)section) + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Class \"Map Fragment\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType" + scarab.iBhigh + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 0 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 42" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_scarab.mp3\"", Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine, Encoding.UTF8);
        }
    }
}
